;gfxFunc

VdpCopy:
; dest in de
; source in hl
; byte in b
rst $10
ld c, $be
otir
ret

LoadTile2Bpp16x16Sprite4Stripped:
ld b, $02
push bc
call LoadTile2Bppv2
ld bc, $20 * 3
add hl, bc
pop bc
call LoadTile2Bppv2
ret

LoadTile2Bpp16x16Sprite2Stripped:
ld b, $02
call LoadTile2Bppv2x4
ld bc, $20
add hl, bc
ld b, $02
call LoadTile2Bppv2x4
ret


LoadTile2Bppv2:
;rst $10
-:
  push bc
  ld b, $08
  --:
    call LoadLine2Bpp
  djnz --
  pop bc
djnz -
ret

LoadTile2Bppv2x4:
;rst $10
-:
  push bc
  ld b, $08
  --:
    call LoadLine2Bppx4
  djnz --
  pop bc
djnz -
ret


LoadLine2Bpp:
-
  ld a, (hl)
   ld d, a
  out ($be), a
  inc hl
  ld a, (hl)
  out ($be), a
  inc hl
   or d
   or e
   ld d, a
  ld a, c
  and $01
  neg
   and d
  out ($be), a
  ld a, c
  rra
  and $01
  neg
   and d
  out ($be), a
ret

LoadLine2Bppx4:
-
  xor a
  out ($be), a
  xor a
  out ($be), a

  ld a, (hl)
  out ($be), a
  inc hl
  ld a, (hl)
  out ($be), a
  inc hl
ret

LoadTileMap:
; bc should be even
-
ld a, (hl)
cp e
jp nz, +
in a, ($be)
in a, ($be)
inc hl
jp ++
+
add a, d
out ($be), a
inc hl
ld a, (hl)
out ($be), a
++
inc hl
dec bc
dec bc
ld a, b
or c
jp nz, -
+
ret


LoadTileMap1:
-:
  rst $08
  push bc
  call LoadTileMapLine1
  ld bc, $40
  add hl, bc
  pop bc
djnz -
ret

LoadTileMapLine1
-:
   ld a, (ix+0)
   inc ix
   add a, d
   out ($be), a
   ld a, e
   out ($be), a
   dec c
   jp nz, -
ret

LoadTileMapRev:
-:
  rst $08
  push bc
  call LoadTileMapLineRev
  ld bc, $40
  add hl, bc
  pop bc
djnz -
ret

LoadTileMapLineRev:
ld b, $00
add ix, bc
dec ix
push bc
-:
   ld a, (ix+0)
   dec ix
   add a, d
   out ($be), a
   ld a, e
   out ($be), a
   dec c
   jp nz, -
pop bc
add ix, bc
inc ix
ret



SpriteSet16x16:
;x in h
;y in l
;n in d
;sprite index in e

;vdp set addr
ld a, e
out ($bf), a
ld a, $7f
out ($bf), a

;y+0 y+0
;y+8 y+8
ld a, l
out ($be), a
out ($be), a
add a, $08
out ($be), a
out ($be), a

;vdp set addr
ld a, e
add a, a
or $80
out ($bf), a
ld a, $7f
out ($bf), a

;x+0 n+0 x+8 n+1
;x+0 n+2 x+8 n+3
ld a, h
out ($be), a
ld a, d
out ($be), a

ld a, h
add a, $08
out ($be), a
inc d
ld a, d
out ($be), a

ld a, h
out ($be), a
inc d
ld a, d
out ($be), a

ld a, h
add a, $08
out ($be), a
inc d
ld a, d
out ($be), a

ret


SpriteSet16x16Mirror:
;x in h
;y in l
;n in d
;sprite index in e

;vdp set addr
ld c, e
ld b, BlockSAT

;y+0 y+0
;y+8 y+8
ld a, l
ld (bc), a
inc bc
ld (bc), a
inc bc
add a, $08
ld (bc), a
inc bc
ld (bc), a
inc bc

;vdp set addr
ld a, e
add a, a
or $80
ld c, a
ld b, BlockSAT

;x+0 n+0 x+8 n+1
;x+0 n+2 x+8 n+3
ld a, h
ld (bc), a
inc bc
ld a, d
ld (bc), a
inc bc

ld a, h
add a, $08
ld (bc), a
inc bc
inc d
ld a, d
ld (bc), a
inc bc

ld a, h
ld (bc), a
inc bc
inc d
ld a, d
ld (bc), a
inc bc

ld a, h
add a, $08
ld (bc), a
inc bc
inc d
ld a, d
ld (bc), a
inc bc

ret

MirrorSAT:
; optimize me
ld h, BlockSAT
ld l, $00

ld a, $00
out ($bf), a
nop
nop
nop
nop
nop
nop
ld a, $7f
out ($bf), a
nop
nop
nop
nop
nop
nop

ld b, $ff
ld c, $be
-
outi
nop
nop
nop
nop
nop
nop
jp nz, -
ret

WaitVCount:
;wait VCount matches c
-
in a, ($7e)
--
ld b, a
in a, ($7e)
cp b
jp nz, --
cp c
jp nz, -
ret

